"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const iterable_1 = require("../utils/iterable");
function distinct(source, keySelector) {
    return iterable_1.iterable(function* () {
        const set = new Set();
        for (const element of source) {
            const key = keySelector(element);
            if (!set.has(key)) {
                set.add(key);
                yield element;
            }
        }
    });
}
exports.distinct = distinct;

//# sourceMappingURL=distinct.js.map
