"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const toSet_1 = require("../reducers/toSet");
const iterable_1 = require("../utils/iterable");
const map_1 = require("./map");
function exclude(source, exclude, keySelector) {
    return iterable_1.iterable(function* () {
        const exclusionSet = toSet_1.toSet(map_1.map(exclude, keySelector));
        for (const element of source) {
            const key = keySelector(element);
            if (!exclusionSet.has(key)) {
                yield element;
            }
        }
    });
}
exports.exclude = exclude;

//# sourceMappingURL=exclude.js.map
