"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const map_1 = require("./map");
function fill(source, value, start, end) {
    if (start === undefined && end === undefined) {
        return map_1.map(source, () => value);
    }
    if (end === undefined) {
        if (start < 0) {
            throw new Error('Invalid start range, use positive index.');
        }
        return map_1.map(source, (elem, idx) => idx >= start ? value : elem);
    }
    if (end < 0) {
        throw new Error('Invalid end range, use positive index.');
    }
    return map_1.map(source, (elem, idx) => idx >= start && idx < end ? value : elem);
}
exports.fill = fill;

//# sourceMappingURL=fill.js.map
