"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const toGroups_1 = require("../reducers/toGroups");
const iterable_1 = require("../utils/iterable");
function groupJoin(source, others, leftKeySelector, rightKeySelector, joinSelector) {
    return iterable_1.iterable(function* () {
        let index = 0;
        const rightMap = toGroups_1.toGroups(others, rightKeySelector, x => x);
        for (const element of source) {
            const leftKey = leftKeySelector(element, index++);
            const rightValues = rightMap.get(leftKey) || [];
            yield joinSelector(element, rightValues);
        }
    });
}
exports.groupJoin = groupJoin;

//# sourceMappingURL=groupJoin.js.map
