"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const toSet_1 = require("../reducers/toSet");
const iterable_1 = require("../utils/iterable");
const map_1 = require("./map");
function intersect(source, others, selector) {
    return iterable_1.iterable(function* () {
        const includedSet = new Set();
        const othersSet = toSet_1.toSet(map_1.map(others, selector));
        for (const element of source) {
            const key = selector(element);
            if (!includedSet.has(key) && othersSet.has(key)) {
                includedSet.add(key);
                yield element;
            }
        }
    });
}
exports.intersect = intersect;

//# sourceMappingURL=intersect.js.map
