"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const toGroups_1 = require("../reducers/toGroups");
const iterable_1 = require("../utils/iterable");
function leftJoin(source, others, leftKeySelector, rightKeySelector, joinSelector) {
    return iterable_1.iterable(function* () {
        let index = 0;
        const rightMap = toGroups_1.toGroups(others, rightKeySelector, x => x);
        for (const element of source) {
            const leftKey = leftKeySelector(element, index++);
            if (rightMap.has(leftKey)) {
                for (const rightMatch of rightMap.get(leftKey)) {
                    yield joinSelector(element, rightMatch);
                }
            }
            else {
                yield joinSelector(element);
            }
        }
    });
}
exports.leftJoin = leftJoin;

//# sourceMappingURL=leftJoin.js.map
