"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const toArray_1 = require("../reducers/toArray");
const iterable_1 = require("../utils/iterable");
function shuffle(source) {
    return iterable_1.iterable(() => {
        const elements = toArray_1.toArray(source);
        // Fisher–Yates shuffle
        // https://en.wikipedia.org/wiki/Fisher%E2%80%93Yates_shuffle
        for (let i = elements.length - 1; i > 0; i--) {
            const j = Math.floor(Math.random() * (i + 1));
            [elements[i], elements[j]] = [elements[j], elements[i]];
        }
        return elements;
    });
}
exports.shuffle = shuffle;

//# sourceMappingURL=shuffle.js.map
