"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const filter_1 = require("./filter");
const iterable_1 = require("../utils/iterable");
function skip(source, count) {
    return iterable_1.iterable(() => {
        return count >= 0 ?
            filter_1.filter(source, (elem, idx) => idx >= count) :
            skipLast(source, -count);
    });
}
exports.skip = skip;
function* skipLast(source, count) {
    const buffer = [];
    let index = 0;
    for (const element of source) {
        buffer.push(element);
        if (index++ - count >= 0) {
            yield buffer.shift();
        }
    }
}

//# sourceMappingURL=skip.js.map
