"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const take_1 = require("./take");
const skip_1 = require("./skip");
function slice(source, start, end) {
    if (start === undefined && end === undefined) {
        return source;
    }
    if (start !== undefined && start < 0) {
        throw new Error('Invalid start range, use positive index.');
    }
    if (end !== undefined && end < 0) {
        throw new Error('Invalid end range, use positive index.');
    }
    // end !== undefined
    if (start === undefined) {
        return take_1.take(source, end);
    }
    // start !== undefined
    if (end === undefined) {
        return skip_1.skip(source, start);
    }
    return skip_1.skip(take_1.take(source, end), start);
}
exports.slice = slice;

//# sourceMappingURL=slice.js.map
