"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const iterable_1 = require("../utils/iterable");
function take(source, count) {
    return count >= 0 ?
        iterable_1.iterable(() => takeFirst(source, count)) :
        iterable_1.iterable(() => takeLast(source, -count));
}
exports.take = take;
function* takeFirst(source, count) {
    let n = count;
    for (const element of source) {
        if (n-- === 0)
            return;
        yield element;
    }
}
function* takeLast(source, count) {
    const result = [];
    for (const element of source) {
        if (result.length === count) {
            result.shift();
        }
        result.push(element);
    }
    for (const element of result) {
        yield element;
    }
}

//# sourceMappingURL=take.js.map
