"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function nth(source, index) {
    return index >= 0 ?
        fromFront(source, index) :
        fromBack(source, -index);
}
exports.nth = nth;
function fromFront(source, index) {
    let n = index;
    for (const element of source) {
        if (!n--) {
            return element;
        }
    }
    return undefined;
}
function fromBack(source, index) {
    const buffer = [];
    for (const element of source) {
        buffer.push(element);
        if (buffer.length > index) {
            buffer.shift();
        }
    }
    return buffer.length === index ? buffer[0] : undefined;
}

//# sourceMappingURL=nth.js.map
