"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function reduce(source, callback, initialValue) {
    let [index, accumulator] = [-1, initialValue];
    for (const element of source) {
        accumulator = ++index === 0 && initialValue === undefined ?
            element :
            callback(accumulator, element, index);
    }
    if (initialValue === undefined && index === -1) {
        throw new Error('Sequence contains no elements.');
    }
    return accumulator;
}
exports.reduce = reduce;

//# sourceMappingURL=reduce.js.map
