"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function toGroups(source, keySelector, valueSelector) {
    let index = 0;
    const map = new Map();
    for (const element of source) {
        const key = keySelector(element, index);
        if (!map.has(key)) {
            map.set(key, []);
        }
        map.get(key).push(valueSelector(element, index++));
    }
    return map;
}
exports.toGroups = toGroups;

//# sourceMappingURL=toGroups.js.map
