"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function toMap(source, keySelector, valueSelector) {
    let index = 0;
    const map = new Map();
    for (const element of source) {
        const key = keySelector(element, index);
        if (map.has(key)) {
            throw new Error(`Duplicate map entry key: ${key}.`);
        }
        map.set(key, valueSelector(element, index++));
    }
    return map;
}
exports.toMap = toMap;

//# sourceMappingURL=toMap.js.map
